// Matrix - algorithm simulation system
// Copyright (C) 2000- 2007 Matrix group
// (See the AUTHORS file and the author tag below for more information
// on the authors.)
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/* $Id: MyVisualAnimator.java,v 1.9 2007/09/07 13:21:21 vkaravir Exp $ */

package applications.exerciseapplet;

import matrix.animation.*;


public class MyVisualAnimator extends VisualAnimator {

    int [] steps = null;
    int currentIndex = 0;
    int lastIndex = 0;


    public MyVisualAnimator(Animator a) {
        super(a);
    }
    
    public int[] getSteps() {
        return steps;
    }


    private void increase(int index) {
        steps[index]++;
    }


    protected void undo() {
        super.undo();
        currentIndex--;
        increase(currentIndex);
    }


    protected void redo() {
        super.redo();
        currentIndex++;
        increase(currentIndex);
    }


    protected void rewind() {
        super.rewind();
        currentIndex = 0;
        increase(currentIndex);
    }


    protected void end() {
        super.end();
        currentIndex = lastIndex;
        increase(currentIndex);
    }


    protected void GoTo(int index, int maximum) {
        // slidebar does nothing here
    }


    protected void initIndices() {
        animator.rewind();
        while (animator.hasNextOperation()) {
            animator.redo();
            lastIndex++;
        }
        currentIndex = lastIndex;
        steps = new int[lastIndex+1];
        rewind();
    }

}
