// Matrix - algorithm simulation system
// Copyright (C) 2000- 2007 Matrix group
// (See the AUTHORS file and the author tag below for more information
// on the authors.)
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
package applications.trakla2.datalogging;

import java.io.Serializable;
import java.util.Date;


public abstract class ExerciseData implements Serializable {
    static final long serialVersionUID = -8307143358041342844L;

    public abstract String operationName();


    String fileName;

    /**
     * Get the value of fileName.
     * @return value of fileName.
     */
    public String getFileName() {
        return fileName;
    }

    /**
     * Set the value of fileName.
     * @param v  Value to assign to fileName.
     */
    public void setFileName(String  v) {
        this.fileName = v;
    }


    String exerciseClassName;

    /**
     * Get the value of exerciseClassName.
     * @return value of exerciseClassName.
     */
    public String getExerciseClassName() {
        return exerciseClassName;
    }

    /**
     * Set the value of exerciseClassName.
     * @param v  Value to assign to exerciseClassName.
     */
    public void setExerciseClassName(String  v) {
        this.exerciseClassName = v;
    }



    private Date timeStamp;

    public Date getTimeStamp() {
        return timeStamp;
    }

    public void setTimeStamp(Date _timeStamp) {
        timeStamp = _timeStamp;
    }



    long seed = 0;

    public long getSeed() {
        return seed;
    }

    public void setSeed(long _seed) {
        seed = _seed;
    }




    String studentid;

    public String getStudentid()  {
        return studentid;
    }

    public void setStudentid(String v) {
    	/*
    	if (v != null)
            studentid = v.toLowerCase();
        else
            studentid = null;
            */
    	studentid = v;
    }

    String exerciseId;

    public String getExerciseId() {
        return exerciseId;
    }

    public void setExerciseId(String value) {
        exerciseId = value;
    }

    int maxPoints;

    public int getMaxPoints() {
	return maxPoints;
    }

    public void setMaxPoints(int value) {
	maxPoints = value;
    }

    String fingerprint;

    public String getFingerprint() {
	return fingerprint;
    }

    public void setFingerprint(String value) {
	fingerprint = value;
    }

    public String toString() {

        StringBuffer buf = new StringBuffer();

        buf.append("timeStamp=");
        buf.append(getTimeStamp());
        buf.append(";operationName=");
        buf.append(operationName());

        buf.append(";exerciseId=");
        buf.append(getExerciseId()+"");

        buf.append(";studentid=");
        buf.append(getStudentid());

        buf.append(";exerciseClassName=");
        buf.append(getExerciseClassName());

        buf.append(";seed=");
        buf.append(getSeed());

        return buf.toString();

    }


}






