// Matrix - algorithm simulation system
// Copyright (C) 2000- 2007 Matrix group
// (See the AUTHORS file and the author tag below for more information
// on the authors.)
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
package applications.trakla2.datalogging;


/*
 * 
 * @author Otto Seppl
 *
 * GradeData and SubmissionData have a load of same methods not in their superclasses
 * but they are essentially the very same class. This class is a kind of a wrapper class
 * for transforming between the two without touching the classes themselves. Touching the
 * classes is risky, as all the stored submissions are made with these classes.
 */
public class GradeToSubmissionData extends SubmissionData {

    private static final long serialVersionUID = 8347078882786194541L;

    public String operationName() { return "grade"; }
    
    public GradeToSubmissionData(GradeData gd){
        setStudentSolution(gd.getStudentSolution());
        setSeed(gd.getSeed());
        setGrade(gd.getGrade());
        //setCourseCode(gd.getCourseCode());
        setExerciseClassName(gd.getExerciseClassName());
        setExerciseId(gd.getExerciseId());
        setFileName(gd.getFileName());
        setFingerprint(gd.getFingerprint());
        setMaxPoints(gd.getMaxPoints());
        //setRound(gd.getRound());
        setStudentid(gd.getStudentid());
        setTimeStamp(gd.getTimeStamp());        

        //AND HERE IS THE ONE AND ONLY DIFFERENCE,
        //setErroneousStepIndex(gd.getErroneousStepIndex()); 
    }
    
}
