// Matrix - algorithm simulation system
// Copyright (C) 2000- 2007 Matrix group
// (See the AUTHORS file and the author tag below for more information
// on the authors.)
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
package applications.trakla2.datalogging;

import java.util.Collection;
import java.util.HashMap;
import java.util.Set;


public class SubmissionData extends ExerciseData {
    static final long serialVersionUID = -8561560406170219275L;

    private HashMap payloads = new HashMap(); 
    private int grade;
    
    
    public String operationName() { return "submit"; }
    
    /**
     * Get the value of grade.
     * @return value of grade.
     */
    public int getGrade() {
        return grade;
    }

    /**
     * Set the value of grade.
     * @param v  Value to assign to grade.
     */
    public void setGrade(int  v) {
        this.grade = v;
    }



    private StructureOperations studentSolution;

    public StructureOperations getStudentSolution() {
        return studentSolution;
    }


    public void setStudentSolution(StructureOperations structureOperations) {
        this.studentSolution = structureOperations;
    }



    public String toString() {
        StringBuffer buf = new StringBuffer();
        buf.append(super.toString());
        buf.append(";grade=");
        buf.append(getGrade()+"");

        buf.append(";fileName=");
        buf.append(getFileName());

        return buf.toString();

    }



    public String studentMessage() {
        StringBuffer msg = new StringBuffer();
        msg.append("Student ");
        msg.append(studentid);
        msg.append(" submitted exercise ");
        msg.append(exerciseId +". Grade=" + grade);
        return msg.toString();
    }

    public void addPayload(String id, Object payload){
        payloads.put(id, payload);
    }
    
    public Object retrievePayload(String id){
        return payloads.get(id);
    }
    
    public String[] getAvailablePayloadIds(){
        Set keySet = payloads.keySet();
        return (String[])keySet.toArray(new String[0]);
    }

    public Object[] getAvailablePayloads(){
        Collection values = payloads.values();
        return values.toArray();
    }
}