package applications.trakla2.util;

import java.io.IOException;
import java.util.Iterator;
import java.util.Properties;
import java.util.StringTokenizer;

/**
 * This class creates from the exercisestrings.properties file the
 * corresponding SQL-commands for initializing the localization
 * 
 * @author oseppala
 */

public class ExerciseLocalizationSQLGenerator {

    /**
     * @param args
     */
    public static void main(String[] args) {
        ClassLoader local = ExerciseLocalizationSQLGenerator.class.getClassLoader();
        Properties exerciseLocalizationStrings = new Properties();
        
        try {
            exerciseLocalizationStrings.load(local.getResourceAsStream("exercisestrings.properties"));
            
            Iterator exerciseIterator = exerciseLocalizationStrings.keySet().iterator();
            
            while (exerciseIterator.hasNext()) {
                String exerciseFilename = (String)(exerciseIterator.next());
                
                // SELECT id from appletparameter where value = exercisefilename
                
                if (exerciseFilename.startsWith("content.")) {
                    String paramList = exerciseLocalizationStrings.getProperty(exerciseFilename);
                    StringTokenizer paramTokenizer = new StringTokenizer(paramList, ",");
                    String eid = "XX";
                    
                    System.out.println("\n\n/* "+ exerciseFilename +" */\n");
                    
                    while (paramTokenizer.hasMoreTokens()) {
                        String param      = paramTokenizer.nextToken().trim();
                        String paramValue = exerciseLocalizationStrings.getProperty(param);
                        System.out.println("INSERT INTO appletstrings VALUES ( "+eid+", en, 0, '"+param+"', '"+paramValue+"' );");
                        
                    }
                    
                }
                
                
            }
            
        } catch (IOException e) {
            System.err.println("File : exerciseStrings.properties coudl not be accessed\nPlease check the running directory");
            e.printStackTrace(System.err);
        }
        
    }

}
