// Matrix - algorithm simulation system
// Copyright (C) 2000- 2007 Matrix group
// (See the AUTHORS file and the author tag below for more information
// on the authors.)
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
package applications.trakla2.viewer;

import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

public class FingerprintHelper {
    public static String getFingerprint(String course, int round, int exercise, 
					String studentId, int maxPoints,
					String exerciseClass) {
	if(studentId == null)
	    return "";
	String fp =  course + round + exercise + maxPoints + System.getProperty("trakla2.server.FINGERPRINT") +
	    exerciseClass + studentId.toUpperCase();
	return fp.trim();
    }

    public static String calculateMD5(String s) throws NoSuchAlgorithmException  {
	MessageDigest md5Digest = MessageDigest.getInstance("MD5");
	return asHex(md5Digest.digest(s.getBytes()));
    }

    private static String asHex(byte[] b) {
        char hex[] = {'0','1','2','3','4','5','6','7','8','9','a','b','c','d','e','f'};
	
	StringBuffer resultString= new StringBuffer();
	for (int i=0; i<b.length;i++){
	    resultString.append(hex[(b[i]>>4)&15]);
	    resultString.append(hex[b[i]&15]);
	}
        return resultString.toString();
    }
}
