// Matrix - algorithm simulation system
// Copyright (C) 2000- 2007 Matrix group
// (See the AUTHORS file and the author tag below for more information
// on the authors.)
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
package content.exercises;

import java.util.Random;

import content.exercises.structures.ExerBin;
import content.exercises.structures.ExerBinSearchTree_DuplicatesRight;
import matrix.animation.Animator;
import matrix.structures.FDT.FDT;
import matrix.structures.FDT.probe.Key;
import matrix.structures.FDT.probe.Table;
import matrix.util.Note;

/**
 * This exercise is mostly the same as BST_Insert. The only difference is 
 * that in this exercise duplicates are added to the right subtree instead of the left subtree.
 * 
 * @author kstalnac
 *
 */
public class BST_Insert_DuplicatesRight extends BST_Insert {



    public BST_Insert_DuplicatesRight() {
        super();
    }
    
    public FDT[] init() {

        ExerBinSearchTree_DuplicatesRight testBST;
        Random R = new Random(seed);
        do {
            // 15-20 keys
            int n = Math.abs(R.nextInt()%6);
            // Can contain duplicates
            S = matrix.util.RandomKey.createNoDuplicateUppercaseRandomKey(R,15)+
                matrix.util.RandomKey.createNoDuplicateUppercaseRandomKey(R,n);
            // Maximum height 6
            testBST = new ExerBinSearchTree_DuplicatesRight();
            for(int i = 0; i < S.length(); i++)
                testBST.insert(new Key(""+S.charAt(i)));
            if (DEBUG)
                System.out.println("iteration - height "+testBST.getHeight());
        } while(testBST.getHeight() > 6);

        t = new Table(S);
        bt = new ExerBin();
        FDT[]  s = { t, bt };
        return s;
    }
    
    public FDT[] solve() {
        Note.out(this, "Solve");
        bst = new ExerBinSearchTree_DuplicatesRight();
        Table tbl = (Table)getInitialStructures()[0];
        Animator a = Animator.getActiveAnimator();
        for (int i=0; i<tbl.size(); i++) {
            a.startOperation();
            bst.insert(tbl.getObject(i));
            a.endOperation();
        }
        Note.out(this, "Solved");
        return new FDT[] { (FDT)bst.getElement() };
    }

    private static final long serialVersionUID = 1750853308433323574L;
}
