//Matrix - algorithm simulation system
//Copyright (C) 2000- 2007 Matrix group
//(See the AUTHORS file and the author tag below for more information
//on the authors.)

//This program is free software; you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation; either version 2 of the License, or
//(at your option) any later version.

//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.

//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package content.exercises;

import java.util.Random;

import content.ExerciseProperties;
import content.interfaces.ButtonExercise;
import content.interfaces.ConfigureVisualType;
import content.interfaces.ModelAnswerNames;
import content.interfaces.SimulationExerciseModel;
import content.interfaces.SimulationExerciseSelfAssessment;

import matrix.simulation.VisualTypeConf;
import matrix.structures.CDT.probe.FaultyBinSearchTree;
import matrix.structures.FDT.FDT;
import matrix.structures.FDT.probe.Table;
import matrix.visual.VisualType;
import matrix.visual.VisualTreeComponent;
import matrix.visual.VisualKey;

public class BinTree_Faulty implements SimulationExerciseSelfAssessment, 
ButtonExercise, 
ModelAnswerNames, 
ConfigureVisualType {
    private Table t;
    private FaultyBinSearchTree tree;

    private String S;
    private static final int TABLE_LEN = 15;
    protected static Random rnd;
    public static final boolean DEBUG = false;

    public BinTree_Faulty() {
    }

    long seed = 1;

    /**
     * Get the value of seed.
     * @return value of seed.
     */
    public long getSeed() {
        return seed;
    }

    /**
     * Set the value of seed.
     * @param v  Value to assign to seed.
     */
    public void setSeed(long  v) {
        this.seed = v;
    }

    public FDT[] init() {
        rnd = new Random(seed);
        StringBuffer bf = new StringBuffer( "ABCDEFGHIJKLMNOPQRSTUVXYZ" );
        for ( int i = 0; i < (25 - TABLE_LEN); i++ ) {
            bf.deleteCharAt( rnd.nextInt( TABLE_LEN - i ) );
        }
        System.out.println("listana: "+bf);
        this.S = bf.toString();
        t = new Table( this.S );
        tree = new FaultyBinSearchTree();

        FDT[] s = {t, tree};
        return s;
    }

    public String[] getStructureNames() {
        ExerciseProperties lang = ExerciseProperties.getInstance();

        String[] s = {lang.get("BINTREE_FAULTY_INPUT_TITLE"), lang.get("BINTREE_FAULTY_TREE_TITLE")}; 
        return s;
    }

    public String getDescription() {
        return "";
        //"Insert the following Keys into an initially empty AVL Tree";
    }

    public String[] buttonNames() {
        ExerciseProperties lang = ExerciseProperties.getInstance();

        String[] s = {lang.get("BINTREE_FAULTY_DELETE_BUTTON_TEXT")}; 
        return s;
    }

    public String[] buttonCommands() {
        String[] s = {"/deleteKey"};
        return s;
    }


    public String[] getModelAnswerNames() {
        ExerciseProperties lang = ExerciseProperties.getInstance();

        String[] s = {lang.get("BINTREE_FAULTY_TREE_MODEL_TITLE")}; 
        return s;
    }


    public SimulationExerciseModel getModelAnswer() {
        return this;
    }

    public FDT[] solve() {
        ExerciseProperties lang = ExerciseProperties.getInstance();
        return new FDT[] {new Table(lang.get("BINTREE_FAULTY_MISSING_MODEL_TITLE"))};
    }



    public FDT[] makeModelAnswer() {
        return solve();
    }



    public FDT[] getInitialStructures() {
        return new FDT[] { new Table(S), new FaultyBinSearchTree() };
    }

    public FDT[] getSimulatedStructures() {
        return new FDT[] { t, tree };
    }

    public FDT[] getAnswer() {
        FDT[] s = {tree};
        return s;
    }

    public int[] judge() {
        if (tree.isBroken())
            return new int[] {1};
        else
            return new int[] {0};
    }



    public int getMaxPoints() {
        return 1;
    }

    public String getFeedbackString() {
        // TODO Auto-generated method stub
        return null;
    }

    public void deleteKey() {
        if (VisualType.read instanceof VisualKey)
            if (VisualType.read.getParent() instanceof VisualTreeComponent)
                VisualType.read.delete();
    }

    public VisualTypeConf[] conf() {
        VisualTypeConf tabl = new VisualTypeConf();
        tabl.enable("matrix.visual.VisualKey", VisualTypeConf.HIGHLIGHT_OPERATION);
        tabl.enable("matrix.visual.VisualKey", VisualTypeConf.DRAG_OPERATION);
        VisualTypeConf tre = new VisualTypeConf();
        tre.enable("matrix.visual.VisualLayeredTree", VisualTypeConf.DROP_OPERATION);
//      tre.enable("matrix.visual.VisualLayeredTree", VisualTypeConf.HIGHLIGHT_OPERATION);
        tre.enable("matrix.visual.VisualKey", VisualTypeConf.HIGHLIGHT_OPERATION);

        return new VisualTypeConf[] { tabl, tre};
    }

    static final long serialVersionUID = -8436352103244731304L;
}
