//Matrix - algorithm simulation system
//Copyright (C) 2000- 2007 Matrix group
//(See the AUTHORS file and the author tag below for more information
//on the authors.)

//This program is free software; you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation; either version 2 of the License, or
//(at your option) any later version.

//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.

//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

//NOT REVISED FOR TRAKLA2

package content.exercises;

import content.ExerciseProperties;
import content.interfaces.SimulationExerciseModel;
import content.interfaces.StyledExercise;
import matrix.animation.Animator;
import matrix.structures.FDT.FDT;
import matrix.structures.FDT.probe.*;
import matrix.structures.other.Deque;
import matrix.util.Note;


public class Deque_Oper implements SimulationExerciseModel, StyledExercise {
    public static final boolean DEBUG = false;
    ArrayList list;
    Table t;
    Deque deq;

    public Deque_Oper() {
    }


    long seed = 1;

    /**
     * Get the value of seed.
     * @return value of seed.
     */
    public long getSeed() {
        return seed;
    }

    /**
     * Set the value of seed.
     * @param v  Value to assign to seed.
     */
    public void setSeed(long  v) {
        this.seed = v;
    }


    public FDT[] init() {
        t = new Table("eRb><FQaj<H>>t");
        list = new ArrayList(20);
        FDT[] s = { t, list };
        return s;
    }



    public String[] getStructureNames() {
        ExerciseProperties lang = ExerciseProperties.getInstance();

        String[] s = {lang.get("DEQUE_OPER_INPUT_TITLE"), lang.get("DEQUE_OPER_DEQUE_TITLE") };
        return s;
    }

    public String getDescription() {
        return ExerciseProperties.getInstance().get("DEQUE_OPER_INSTRUCTIONS");
    }

    public FDT[] solve() {
        deq = new Deque();
        String c;
        Animator a = Animator.getActiveAnimator();
        for(int i = 0; i < t.size(); i++) {
            c =  t.getObject(i).toString();
            Note.out(this, "c: '" + c + "'");
            a.startOperation();
            if(c.equals("<")) {
                Note.out(this, "get()");
                deq.get();
            } else if(c.equals(">")) {
                Note.out(this, "pop()");
                deq.pop();
            } else if(Character.isUpperCase(c.charAt(0))) {
                Note.out(this, "put " + c);
                deq.put(c);
            }
            else if(Character.isLowerCase(c.charAt(0))) {
                Note.out(this, "push " + c);
                deq.push(c);
            }
            else
                Note.err(this, "Illegal input");
            a.endOperation();
        }
        return new FDT[] { deq };
    }


    public FDT[] makeModelAnswer() {
        return solve();
    }


    public FDT[] getAnswer() {
        return new FDT[] { list };
    }

    public String[] getStructureVisualisations() {
        return new String[] { null, null };
    }


    public String[] getModelAnswerVisualisations() {
        return new String[] { "list" };
    }

    public SimulationExerciseModel getModelAnswer() {
        return null;
    }

    public FDT[] getInitialStructures() {
        throw new RuntimeException("not implemented");
    }

    static final long serialVersionUID = -3059082919445834235L;
}
