// Matrix - algorithm simulation system
// Copyright (C) 2000- 2007 Matrix group
// (See the AUTHORS file and the author tag below for more information
// on the authors.)
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package content.exercises;

import content.ExerciseProperties;
import matrix.structures.FDT.FDT;

public class Dijkstra extends Prim {

    // constructor

    public Dijkstra() {}

    public String getDescription() {
        ExerciseProperties lang = ExerciseProperties.getInstance();

        String S= lang.get("DIJKSTRA_INSTRUCTIONS")+" " + keys.charAt(0) +".\n\n";
        for (int i=0; i<keys.length(); i++)
            S+=NodeList[i]+"\n";
        return S;
    }

    public FDT[] solve() {
        //Note.out(this, "Solve");

        SSSP_Dijkstra dijkstra = new SSSP_Dijkstra(ModelVertex, ModelVertex[0]);

        dijkstra.run();

        //Note.out(this, "Solved");
        return new FDT[] { modelgraph };
    }


    static final long serialVersionUID = 1561932458506049644L;

}
