package content.exercises.sda.structures;

import java.util.Comparator;

import matrix.structures.CDT.CDT;

public class SortedList extends SinglyLinkedList {
    
    protected final Comparator comparator;
    
    public SortedList(Comparator comparator) {
        this.comparator = comparator;
    }

    public CDT insert(Object key) {
        if (key != null) {
            if (this.isEmpty()) {
                this.setHeadNode(new Node(key, null));
                this.size.inc();
            } else {
                if (this.comparator.compare(key, this.getHeadNode().getKey()) < 0) {
                    // Insert at the start of the list.
                    this.setHeadNode(new Node(key, this.getHeadNode()));
                    this.size.inc();
                } else {
                    Node previousNode = this.getHeadNode();
                    Node currentNode;
                    while (previousNode.hasNext()) {
                        currentNode = previousNode.getNextNode();
                        if (this.comparator.compare(key, currentNode.getKey()) < 0) {
                            previousNode.setNext(new Node(key, currentNode));
                            this.size.inc();
                            return this;
                        }
                        previousNode = currentNode;
                    }
                    // Insert at the end of the list.
                    previousNode.setNext(new Node(key));
                    this.size.inc();
                }
            }
        }
        return this;
    }
    
    private static final long serialVersionUID = 9198032923124578182L;
}
