// Matrix - algorithm simulation system
// Copyright (C) 2000- 2007 Matrix group
// (See the AUTHORS file and the author tag below for more information
// on the authors.)
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package content.exercises.structures;

import matrix.structures.FDT.*;
import matrix.structures.util.MatrixComparable;

public class ExerColoringRBTree extends ExerRBTree {
	
	public class ExerColoringRBNode extends ExerRBNode {
		
		
		private static final long serialVersionUID = 5667790384974880299L;
		
		public ExerColoringRBNode() {
			super();
			setColorChangeEnabled(true);
		}
		
		public ExerColoringRBNode(MatrixComparable key) {
			super(key);
			setColorChangeEnabled(true);
		}
		
		public Tree getNewNode(Object key) {
			//Note.out(this, "create new node " + key);
			ExerColoringRBNode tmp =  new ExerColoringRBNode((MatrixComparable)key);
			tmp.setRed(true);
			return tmp;
		}
	}
	
	public Tree getNewNode(Object key) {
		//Note.out(this, "create new ExerColoringRBNode " + key);
		return new ExerColoringRBNode((MatrixComparable)key);
	}
	
	static final long serialVersionUID = -8279204555769956022L;
}
