// Matrix - algorithm simulation system
// Copyright (C) 2000- 2007 Matrix group
// (See the AUTHORS file and the author tag below for more information
// on the authors.)
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package content.exercises.structures;

import matrix.animation.Animator;
import matrix.structures.FDT.probe.Table;

/**
 * A Key which is only visible when selected.
 * 
 * @see InvisibleKeyTable
 */
public class InvisibleKeyTable extends Table {
//  private InvisibleKey[] current;
    
//  private int currPos = -1;
    
    
    public InvisibleKeyTable(String s) {
        this(s, 1);
    }
    
    public InvisibleKeyTable(String[] s) {
        this(s, 1);
    }
    
    public InvisibleKeyTable(String s, int selections) {
        this(makeKeys(s), selections);
    }
    
    public InvisibleKeyTable(String[] s, int selections) {
        this(makeKeys(s), selections);
    }
    
    public InvisibleKeyTable(InvisibleKey[] keys, int selections) {
        super(keys);
        for (int i = 0; i < keys.length; i++) {
            keys[i].setParent(this);
        }
//      current = new InvisibleKey[selections];
    }
    
    private static InvisibleKey[] makeKeys(String[] s) {
        InvisibleKey[] keys = new InvisibleKey[s.length];
        for (int i = 0; i < keys.length; i++)
            keys[i] = new InvisibleKey(s[i]);
        return keys;
    }
    
    private static InvisibleKey[] makeKeys(String s) {
        InvisibleKey[] keys = new InvisibleKey[s.length()];
        for (int i = 0; i < keys.length; i++)
            keys[i] = new InvisibleKey(s.substring(i, i + 1));
        return keys;
    }
    
    public void setSelectedKey(InvisibleKey caller) {
        Animator.getActiveAnimator().startOperation();
        /*         currPos++;
         if (currPos >= current.length) {
         // clear selections
          clear();
          currPos = 0;
          }
          current[currPos] = caller;*/
        clear();
        caller.set();
        Animator.getActiveAnimator().endOperation();
    }
    
    /*       public int[] getSelectedIndices() {
     int[] selections = new int[current.length];
     for (int i=0;i<current.length;i++)
     selections[i]=-1;
     // iterate over the array to search for the selected indices
      int selPos = 0;
      for (int j = 0; j < current.length; j++) {
      for (int i = this.getFirst(); i <= this.getLast(); i++) {
      if (current[j] != null && current[j].getIdentityString().equals(((InvisibleKey)getObject(i)).getIdentityString())) {
      selections[selPos] = i;
      selPos++;
      break;
      }
      }
      }
      return selections;
      }*/
    
    public void clear() {
        /*         for (int i = 0; i < current.length; i++) {
         if (current[i] != null)
         current[i].clear();
         current[i] = null;
         }
         currPos = -1;*/
        for (int i = 0; i < size(); i++) {
            ((InvisibleKey)getObject(i)).clear();
        }
    }
    static final long serialVersionUID = 6133594647901732337L;
}
