// Matrix - algorithm simulation system
// Copyright (C) 2000- 2007 Matrix group
// (See the AUTHORS file and the author tag below for more information
// on the authors.)
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/* $Id: OutputTableCounting.java,v 1.8 2007/09/10 08:09:08 vkaravir Exp $ */

package content.exercises.structures;

import matrix.structures.FDT.probe.Key;
import matrix.structures.FDT.probe.Table;


/**
 * A table of Objects that can be visualised as an Array in Matrix. It is possible
 * to create a "random table", which will randomize its keys each time it is
 * refreshed from the GUI. The random table uses three letter keys.
 */
public class OutputTableCounting extends Table {
    
    private AuxiliaryTableCounting ATC;
    
    public OutputTableCounting(String s, AuxiliaryTableCounting atc) {
        super();
        ATC=atc;
        for (int i=0; i<s.length(); i++){
            super.setObject(new Key(s.substring(i,i+1)), i);
        }
        //setFirst(1);
    }
    
    public OutputTableCounting(String s, int zero, AuxiliaryTableCounting atc) {
        super();
        ATC=atc;
        for (int i=0; i<s.length(); i++){
            super.setObject(new Key(s.substring(i,i+1)), i+zero);
        }
        setFirst(zero);
    }
    
    
    public void setObject(Object obj, int address) {
        
        Key k = new Key(obj.toString());
        
        super.setObject(k,address);
        int a = Integer.parseInt(obj.toString());
        
        ATC.decrement(a);
    }
    
    
    
    static final long serialVersionUID = 689132702325018701L;    
}