// Matrix - algorithm simulation system
// Copyright (C) 2000- 2007 Matrix group
// (See the AUTHORS file and the author tag below for more information
// on the authors.)
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/* $Id: TableMergeSort.java,v 1.7 2007/09/10 08:09:07 vkaravir Exp $ */

package content.exercises.structures;

import matrix.structures.FDT.probe.Key;
import matrix.structures.FDT.probe.Table;


/**
 * A table of Objects that can be visualised as an Array in Matrix. It is possible
 * to create a "random table", which will randomize its keys each time it is
 * refreshed from the GUI. The random table uses three letter keys.
 */
public class TableMergeSort extends Table {
    
    
    
    
    
    public TableMergeSort(String s) {
        super();
        for (int i=0; i<s.length(); i++){
            super.setObject(new Key(s.substring(i,i+1)), i);
        }
        
    }
    
    
    public void setObject(Object obj, int address) {
        super.setObject(new Key(obj + ""),address);
    }
    
    static final long serialVersionUID = -1616255674495920893L;
}