package content.interfaces;

/**
 * GradeDialogLayout is used to configure the grade dialog.
 * For example it can be set that model answer is not shown in the
 * grade dialog, if the comparison has all the same information
 * 
 * @author lhakulin
 *
 */

public interface GradeDialogLayout {

	/**
	 * @return true if model answer is shown in the grade dialog
	 * false otherwise
	 */
	public boolean showModelAnswerInGradeDialog();
	
	/**
	 * @return true if comparison is shown in the grade dialog
	 * false otherwise
	 */
	public boolean showComparisonInGradeDialog();
}
