// Matrix - algorithm simulation system
// Copyright (C) 2000- 2007 Matrix group
// (See the AUTHORS file and the author tag below for more information
// on the authors.)
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
package content.interfaces;

import java.awt.GridBagConstraints;

public interface LayoutExercise {

    /**
     * Return the constraints for the exercise
     * @return Exercise constraints
     */
	public GridBagConstraints[] getConstraints();
	
    /**
     * Return the constraints for model answer.
     * @return Model answer constraints
     */
	public GridBagConstraints[] getModelAnswerConstraints();

    /**
     * Return the constraints for comparison panel.
     * If null is returned comparison panel uses constraints from
     * <code>getModelAnswerConstraints()</code>
     * @return Comparison constraints or null
     */
	public GridBagConstraints[] getComparisonConstraints();
}
