// Matrix - algorithm simulation system
// Copyright (C) 2000- 2007 Matrix group
// (See the AUTHORS file and the author tag below for more information
// on the authors.)
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/*$Id: MultipleQuestions.java,v 1.2 2007/09/07 13:41:49 vkaravir Exp $*/

package content.interfaces;

/** This is an interface for exercises that has a number of questions that are judged separately. 
 * Only SimulationExercieModel type of exercises can have multiple questions. If other types
 * are needed to be supported as well, Jury should be modified accordingly.
 */
public interface MultipleQuestions extends SimulationExerciseModel {

    /** @return the number of separately judged answers. */
    public int numberOfQuestions();

    /** Change the active animator to contain the model solution for the i'th question. */
    public void changeAnimator(int i);

    static final long serialVersionUID = 3308804471066187220L;
}
