// Matrix - algorithm simulation system
// Copyright (C) 2000- 2007 Matrix group
// (See the AUTHORS file and the author tag below for more information
// on the authors.)
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
package content.interfaces;

import matrix.animation.Animator;
import matrix.structures.FDT.FDT;

public interface StateLegality {

    
    /**
     * Returns whether the last state in this animator does not
     * violate any structural propeties (heap property, search structure properties etc.)
     * 
     * @param   structures struxtures used in this exercise
     * @param   animator animator that controls the structures
     * @return  is the last state legal in structural sense
     */    
    public boolean legalEndState(Animator animator, FDT[] structures);
    
    /**
     * Returns whether the given state does not
     * violate any structural propeties (heap property, search structure properties etc.)
     * 
     * @param   structures structures used in this exercise
     * @return  is the state legal in structural sense
     */
    public boolean legalState(FDT[] structures);
    
}
