// Matrix - algorithm simulation system
// Copyright (C) 2000- 2007 Matrix group
// (See the AUTHORS file and the author tag below for more information
// on the authors.)
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/**
 * This interface can be used to convey information about visualtype placement
 * with a layout that has been split into many columns
 * Otto Sepp&auml;l&auml; 3.2.2004
 */

package content.interfaces;
public interface UsesSplit{

    /**
     * Returns an integer array that identifies the column in which the corresponding VisualType should be placed
     */
    public int[] getPanelInfo();

    /**
     * Returns the desired number of columns in the layout
     */
    public int getNumberOfPanels();

}
