// Matrix - algorithm simulation system
// Copyright (C) 2000- 2007 Matrix group
// (See the AUTHORS file and the author tag below for more information
// on the authors.)
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
package matrix.animation;

import matrix.structures.FDT.FDT;
import java.io.Serializable;

public class AnimatedStructures implements Serializable  {

    private static final long serialVersionUID = 6560234118742578171L;

    private FDT[] structures; 
    private Animator animator; 

    public AnimatedStructures(FDT[] structures, Animator animator){
        this.structures = structures;
        this.animator   = animator;
    }
    
    public FDT[] getStructures() {        
        return this.structures;
    }

    public void setStructures(FDT[] structures) {        
        this.structures = structures;
    }

    public Animator getAnimator() {        
        return this.animator;
    }

    public void setAnimator(Animator animator) {        
        this.animator = animator;
    }
}



