// Matrix - algorithm simulation system
// Copyright (C) 2000- 2007 Matrix group
// (See the AUTHORS file and the author tag below for more information
// on the authors.)
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/* $Id: Array.java,v 1.8 2007/09/07 13:41:46 vkaravir Exp $ */

package matrix.structures.FDT;
/**
 * Interface for arrays in Matrix.
 */
public interface Array extends FDT {

    /**
     * Returns the Object in the param address.
     * @param address the index of the Object to be retrieved
     */
    public Object getObject(int address);
    /**
     * Sets the param Object in the param address index in this VirtualArray.
     * @param o the Object to be inserted
     * @param address the index where the param Object is to be inserted
     */
    public void setObject(Object o, int address);
    /**
     * Returns the index of the first object stored in this Array.
     * @return minimum index
     */
    public int getFirst();
    /**
     * Returns the index of the last object stored in this Array.
     * @return maximum index
     */
    public int getLast();

    /**
     * Sets the address of the first element in this array.
     * @param i the new address (index) for the first element of the array
     */
    public void setFirst(int i);

    /**
     * Sets the address of the last element in this array.
     * @param i the new address (index) for the last element in array
     */
    public void setLast(int i);

    static final long serialVersionUID = 5883012307108877563L;
}
