/*
 * Matrix -- algorithm simulation system
 * Copyright (C) 2000-2004 Matrix group
 * (See the AUTHORS file and the author tag below for more information
 * on the authors.)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* $Id: Matrix.java,v 1.2 2007/11/25 20:46:58 archie Exp $ */

package matrix.structures.FDT;
/**
 * Interface for arrays in Matrix.
 */
public interface Matrix extends FDT, Array {

    /**
     * Returns the Object in the address (i,j).
     * @param the indexes of the Object to be retrieved
     */
    public Object getObject(int i, int j);
    /**
     * Sets the param Object in the param address (i,j) in this 2D array.
     * @param o the Object to be inserted
     * @param the indexes (i,j) where the param Object is to be inserted
     */
    public void setObject(Object o, int i, int j);
    /**
     * Returns the width of the matrix.
     * @return the number of rows
     */
    public int getRows();
    /**
     * Returns the height of the matrix.
     * @return the number of columns 
     */
    public int getColumns();

    /**
     * Sets the width of the matrix.
     * @param i the new number of rows
     */
    public void setRows(int i);

    /**
     * Sets the height of the matrix.
     * @param i the new number of columns
     */
    public void setColumns(int i);
    
    public String getIndexName(int i);
    public String getColumnIndexName(int i);

    
}
