// Matrix - algorithm simulation system
// Copyright (C) 2000- 2007 Matrix group
// (See the AUTHORS file and the author tag below for more information
// on the authors.)
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
package matrix.structures.FDT;

public interface Struct extends FDT {

    /**
     * Fetches the names of all fields in the struct
     * 
     * @return names of the fields
     */
    
    public String[] getFieldNames();
    
    /**
     *  Fetches the name of the i:th field in the struct
     * @param location the index of the field fetched
     * @return name of the field
     */
    
    public String getFieldName(int location);
    
    /**
     *  Fetches an array containing values of all fields in this struct.
     * @return an array containing values of all fields
     */
    
    public Object[] getFields();

    /**
     *  Fetches the value of the i:th field in the struct.
     *  
     * @param location the index of the field fetched
     * @return the value of the i:th field in the struct
     */
    
    public Object getField(int location);
    
    /**
     * Sets the value of one field
     * 
     * @param value the new value for the field
     * @param location the index of the field to be set
     */
    
    public void setField(Object value, int location);
    
}

