// Matrix - algorithm simulation system
// Copyright (C) 2000- 2007 Matrix group
// (See the AUTHORS file and the author tag below for more information
// on the authors.)
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
package matrix.structures.FDT.probe;

import java.io.Serializable;

/** Class for edges of a <code>GeometricGraph</code>. Implemented this way
 * in order to make it easier to have several different kinds of edge
 * implementations. For example, if a DCEL is used the edges need to store
 * certain kind of information that is not required when we just wish
 * to draw a geometric graph.
 * 
 * @author jtn
 *
 */

public class GeometricEdge implements Serializable {

	private int v1, v2;
	
	public GeometricEdge(int i, int j) {
		v1 = i;
		v2 = j;
	}
	
	public int getSource() {
		return v1;
	}
	
	public int getDestination() {
		return v2;
	}
}
