// Matrix - algorithm simulation system
// Copyright (C) 2000- 2007 Matrix group
// (See the AUTHORS file and the author tag below for more information
// on the authors.)
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/* $Id: Source.java,v 1.2 2007/09/07 13:42:39 vkaravir Exp $ */
/* 24/05/2006 moved from package matrix.structures.FDT (vkaravir) */ 

package matrix.structures.FDT.substructures;

import matrix.structures.FDT.FDT;

/**
 * Source is a common interface for all nodes that implement references.
 * If a reference is selected, the source will be notified for this.
 */

public interface Source extends FDT {
    public void referenceSelectedTo(FDT to);
    public boolean isVisitedReferenceTo(FDT to);
}
