// Matrix - algorithm simulation system
// Copyright (C) 2000- 2007 Matrix group
// (See the AUTHORS file and the author tag below for more information
// on the authors.)
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/* $Id: XYCoordinatesAdapter.java,v 1.6 2007/09/07 13:37:06 vkaravir Exp $ */

package matrix.structures.adaptation;

import matrix.util.Note;

/** This adapter keeps track of StaticXYCoordinates */
public class XYCoordinatesAdapter implements matrix.structures.coordinates.StaticXYCoordinates {
    int n;
    int[] xc;
    int[] yc;
    
    public XYCoordinatesAdapter(int n) {
	Note.out(this, "n="+n);
	this.n=n;
	xc = new int[n];
	yc = new int[n];
	
	for (int i=0; i<n; i++) {
	    xc[i] = i*20;
	    yc[i] = i*20; // 0?
	}
    }
    
    public int getX(int vertex) { 
	if ((vertex >= 0) && (vertex < n))
	    return xc[vertex]; 
	else {
	    return 0;
	}
    }

    public int getY(int vertex) { 
	if ((vertex >= 0) && (vertex < n))
	    return yc[vertex]; 
	else
	    return 0;
    }

    public void setCoordinates(int vertex, int x, int y) {
	if (vertex < n) {
	    xc[vertex]=x;
	    yc[vertex]=y;
	} else {
	    int xcp[] = new int[vertex+1];
	    int ycp[] = new int[vertex+1];
	    
	    for (int i=0; i<vertex+1; i++) {
		if (i<n) {
		    xcp[i] = xc[i];
		    ycp[i] = yc[i];
		} else if (i<vertex) {
            xcp[i] = 0;
            ycp[i] = 0;
        } else {
		    xcp[i] = x;
		    ycp[i] = y;
		}
	    }
	    xc = xcp;
	    yc = ycp;
	    n = xcp.length;
	}
    }
}
