// Matrix - algorithm simulation system
// Copyright (C) 2000- 2007 Matrix group
// (See the AUTHORS file and the author tag below for more information
// on the authors.)
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package matrix.structures.algorithms;

import java.awt.Color;

import matrix.decoration.*;
import matrix.structures.FDT.substructures.Vertex;

public class Depth_First_Search extends Graph_Traverse {

  private int time;

    public Depth_First_Search() {
	super();
	time = 0;
    }

    public void run() {
      time = 0;
	if(dg.getElement() instanceof Vertex)
	    visit((Vertex)dg.getElement());
	Vertex[] vertices = dg.getVertices();
	for(int i = 0; i < vertices.length; i++) {
	    if(!isVisited(vertices[i]))
		visit(vertices[i]);
	}
    }

    public void visit(Vertex v) {
      super.visit(v);
      if(v instanceof Styled) {
	((Styled)v).getStyleSheet().setLabel(++time + "/");
      }
      Vertex[] vertices = v.getSuccessors();
      for (int i=0; i<vertices.length; i++)
	if(notVisited(vertices[i])) {
	  if(v instanceof Styled) {
	      ((Styled)v).getStyleSheet().setReferenceColor(vertices[i], Color.black);
	      
	  }
	  visit(vertices[i]);
	}
      super.finish(v);
      if(v instanceof Styled) {
	StyleSheet ss = ((Styled)v).getStyleSheet();
	ss.setLabel(ss.getLabel() + ++time);
      }
    }
}
