// Matrix - algorithm simulation system
// Copyright (C) 2000- 2007 Matrix group
// (See the AUTHORS file and the author tag below for more information
// on the authors.)
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package matrix.structures.other;
import matrix.structures.CDT.*;
import matrix.structures.FDT.probe.Table;

public class IteratedOperations {

    // Helper method for serializing tables to make multiple CDT
    // insertions
    
    public static final void iteratedInsert(CDT cdt, Table t){
        for (int i=0; i<t.size(); i++)
            cdt.insert(t.getObject(i));
    }

    // Helper method for serializing tables to make multiple CDT
    // insertions as if the String was returned by RandomKey
    
    public static final void iteratedInsert(CDT cdt, String s){
        for (int i=0; i<s.length(); i++)
            cdt.insert(s.substring(i,i+1));
    }
    
    // Helper method for serializing tables to make multiple CDT
    // insertions 
    
    public static final void iteratedInsert(CDT cdt, int[] intArray){
        for (int i=0; i<intArray.length; i++)
            cdt.insert(intArray[i]+"");
    }
}
