// Matrix - algorithm simulation system
// Copyright (C) 2000- 2007 Matrix group
// (See the AUTHORS file and the author tag below for more information
// on the authors.)
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
package matrix.structures.spatial.FDT.probe;

import java.awt.geom.Line2D;
import java.awt.geom.Point2D;

import matrix.structures.spatial.PaintingStyleDecorator;
import matrix.structures.spatial.SpatialComparable;

public class LineSegment extends PolyLine {

    public LineSegment(int x1, int y1, int x2, int y2, PaintingStyleDecorator psd) {
        this(new java.awt.Point(x1, y1), new java.awt.Point(x2, y2), psd);
    }
    
    public LineSegment(java.awt.Point p1, java.awt.Point p2, PaintingStyleDecorator psd) {
        super(new Point2D[]{p1, p2}, psd);
    }

    public java.awt.Point getP1() {
        return this.getPoints()[0].getPoint();
    }
    
    public java.awt.Point getP2() {
        return this.getPoints()[1].getPoint();
    }
    
    public Line2D getLine2D() {
        return new Line2D.Double(this.getP1(), this.getP2());
    }
    
    public boolean contains(SpatialComparable sc) {
        // TODO Auto-generated method stub
        return super.contains(sc);
    }
    
    public boolean equals(SpatialElement o) {
        // TODO Auto-generated method stub
        return super.equals(o);
    }
    
    public boolean equals(double a, double b) {
        // TODO Auto-generated method stub
        return super.equals(a, b);
    }
    
    public boolean equals(Object k) {
        // TODO Auto-generated method stub
        return super.equals(k);
    }
    
    public boolean spatialEquals(Object o) {
        // TODO Auto-generated method stub
        return super.spatialEquals(o);
    }
    
    public boolean intersects(SpatialComparable sc) {
        // TODO Auto-generated method stub
        return super.intersects(sc);
    }
    
    

}
