// Matrix - algorithm simulation system
// Copyright (C) 2000- 2007 Matrix group
// (See the AUTHORS file and the author tag below for more information
// on the authors.)
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
package matrix.structures.spatial.FDT.probe;

import java.awt.geom.GeneralPath;
import java.awt.geom.Point2D;

import matrix.structures.spatial.PaintingStyleDecorator;

public class Polygon extends PolyLine{

	public Polygon() {
		super();
	}
	
    public Polygon(Point[] p) {
        this(p, "");
    }

        
    public Polygon(Point[] p, String key) {
		super(p, key);
		GeneralPath path = getPath();
		path.lineTo((float)p[0].getX(), (float)p[0].getY());
	}
	
	public Polygon(double[] x, double[] y, String key) {
		super(x,y,key);
		GeneralPath path = getPath();
		path.lineTo((float)x[0], (float)y[0]);
	}

    public Polygon(Point2D[] p) {
        this(p, "");
    }

    public Polygon(Point2D[] p, PaintingStyleDecorator psd) {
        this(p, "");
        this.setPaintingStyleDecorator(psd);
    }

    public Polygon(Point2D[] p, String key) {
        super(p, key);
        GeneralPath path = getPath();
        //path.lineTo((float)p[0].getX(), (float)p[0].getY());
        path.closePath();
    }

    public boolean equals(Object o) {
		if(o instanceof Polygon) {
			return spatialEquals(o) && 
			getComparisonString().equals(((Polygon)o).getComparisonString());			
		}
		return false;
	}
	
}
