// Matrix - algorithm simulation system
// Copyright (C) 2000- 2007 Matrix group
// (See the AUTHORS file and the author tag below for more information
// on the authors.)
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package matrix.uitools;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;




/**
 * @author Petri Tenhunen
 */ 
public class InfoDialog extends JFrame {

    private JTextArea infoTxt = new JTextArea("",5, 50);//, TextArea.SCROLLBARS_NONE);

    private static InfoDialog singleton = null;

    private StringBuffer txt;
    
    private InfoDialog() {
	super("Description");
	infoTxt.setEditable(false);

	// connect listeners
	this.addWindowListener(new WindowAdapter() {
	    public void windowClosing(WindowEvent e) { 
	      setVisible(false); }
	  });

	getContentPane().add(infoTxt);
	pack();
	//show();
	setVisible(false);
    }

    public static InfoDialog getInfoDialog() {
	if (singleton == null) {
	    singleton = new InfoDialog();
	}
	return singleton;
    }
    
    public Dimension getPreferredSize() {
	return new Dimension(300,300);
    }
    
    public void setInfoTxt(String txt) {
	//infoTxt.insert(txt,0);
	infoTxt.setText(txt);
	//infoTxt.setText(cutLines(txt,infoTxt.getColumns()));
	validate();
    }
    
    public void clear() {
	//infoTxt.insert("\n",0);
	infoTxt.setText(" ");
	validate();
    }    
}



