// Matrix - algorithm simulation system
// Copyright (C) 2000- 2007 Matrix group
// (See the AUTHORS file and the author tag below for more information
// on the authors.)
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package matrix.uitools;

import java.awt.*;
import javax.swing.*;
import java.awt.print.*;

public class MatrixPrintable implements Printable {

    JPanel sp;
    int pageNum = 0;

    public MatrixPrintable(JPanel sp) {
	this.sp = sp; // this should be the StructurePanel
    }

    public MatrixPrintable(JPanel sp, int pageNum) {
	this.sp = sp;
	this.pageNum = pageNum;
    }

    /**
     * Prints the page with given number into the given <code>Graphics</code>
     * context in the given <code>PageFormat</code>.
     *
     * @param g the context into which the page is drawn
     * @param pageFormat format of the page to be drawn
     * @param pageNumber number of the page to be drawn, zero based
     * 
     * @return PAGE_EXIST if the page is succesfully printed or NO_SUCH_PAGE
     * if page with pageNumber doesn't exist.
     */
    public int print (Graphics g, PageFormat pageFormat, int pageNumber) {
	if (pageNumber == pageNum) {
	    g.translate((int)pageFormat.getImageableX(),
			(int)pageFormat.getImageableY());
	    sp.print(g);
	    return (PAGE_EXISTS);
	}
	else
	    return (NO_SUCH_PAGE);
    }
}
