// Matrix - algorithm simulation system
// Copyright (C) 2000- 2007 Matrix group
// (See the AUTHORS file and the author tag below for more information
// on the authors.)
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package matrix.uitools.actions;

import java.awt.event.ActionEvent;

import javax.swing.Action;
import javax.swing.ImageIcon;

import matrix.animation.Animator;

public class AnimatorBeginAction extends AbstractMatrixAction {
    
    private static final long serialVersionUID = -7830454063013339756L;
    public static final String DEFAULT_NAME = "Begin";
    
    public AnimatorBeginAction() {
        super(DEFAULT_NAME);
        init();
    }
    
    public void actionPerformedOn(ActionEvent event) {
        Animator animator = getFrame().getStructurePanel().getAnimator();
        if (!animator.hasPreviousOperation()) {
            setEnabled(false);
            return;
        }
        while (animator.hasPreviousOperation()) {
            animator.undo();
            
            //by calling this in every step correct visualizations are created
            getFrame().getStructurePanel().fireActionEvent(new ActionEvent(this, 0, "undo")); 
        }
    }
    
    private void init() {
        ImageIcon ii = getImageIcon("pics/Rewind16.gif");
        if (ii != null)
            putValue(Action.SMALL_ICON, ii);
        putValue(Action.SHORT_DESCRIPTION, "Rewinds the animator.");
        setEnabled(false);
    }
    
    public void updateState() {
        setEnabled(getFrame().getStructurePanel().getAnimator().hasPreviousOperation());
    }
}
