// Matrix - algorithm simulation system
// Copyright (C) 2000- 2007 Matrix group
// (See the AUTHORS file and the author tag below for more information
// on the authors.)
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
package matrix.uitools.actions;

import java.awt.event.ActionEvent;

import javax.swing.Action;
import javax.swing.ImageIcon;

import matrix.animation.Animator;

public class AnimatorForwardAction extends AbstractMatrixAction {
	
    private static final long serialVersionUID = -5656789912773593943L;
    public static final String DEFAULT_NAME = "Forward";
	public AnimatorForwardAction() {
		super(DEFAULT_NAME);
		init();
	}
	
	public void actionPerformedOn(ActionEvent event) {
	    Animator animator = getFrame().getStructurePanel().getAnimator();
	    if (!animator.hasNextOperation()) {
	        setEnabled(false);
	        return;
	    }
	    if ((event.getModifiers() & ActionEvent.SHIFT_MASK) != 0)
	        animator.GoTo(animator.getState() + 1, animator.getMaximum());
	    else
	        animator.redo();
	    getFrame().getStructurePanel().getVisualAnimator().fireActionEvent(new ActionEvent(this, event.getID(), null));                
	    getFrame().validate();
	}
	
	private void init() {
	    ImageIcon ii = getImageIcon("pics/StepForward16.gif");
	    if (ii != null)
	        putValue(Action.SMALL_ICON, ii);
        putValue(Action.SHORT_DESCRIPTION, "Moves the animator one step forward. If you hold down the SHIFT-key, moves only one microstep.");
        setEnabled(false);
	}
	
    public void updateState() {
        setEnabled(getFrame().getStructurePanel().getAnimator().hasNextOperation());
    }
}
