// Matrix - algorithm simulation system
// Copyright (C) 2000- 2007 Matrix group
// (See the AUTHORS file and the author tag below for more information
// on the authors.)
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package matrix.util;

import java.awt.FlowLayout;
import javax.swing.*;
import java.awt.event.*;

/**
 * Dialog that asks a question from user. Answer is yes or no.
 *
 * @author Kimmo Stalnacke
 */
public class YesNoDialog extends JDialog implements ActionListener {

    private JButton yes = new JButton("Yes");
    private JButton no = new JButton("No");
    private boolean result = false;

    /**
     * Constructor
     * @param parent Owner for this dialog
     * @param message Question to be asked
     * @param title Title for this dialog
     */
    public YesNoDialog(JFrame parent, String message, String title) {
	super(parent, true);
	
	this.addWindowListener(new WindowAdapter() {
		public void windowClosing(WindowEvent e) {dispose(); }
	    });

	this.add("Center", new JLabel(message));
	this.setTitle(title);
	JPanel p = new JPanel();
	p.setLayout(new FlowLayout());
	yes.addActionListener(this);
	p.add(yes);
	no.addActionListener(this);
	p.add(no);
	this.add("South", p);
	//this.setSize(300,100);
	this.setLocation(300, 300);
	this.pack();
	this.setVisible(true);
    }  
  
    public void actionPerformed(ActionEvent evt) {
	if (evt.getSource() == yes)
	    result = true;
	else
	    result = false;
	this.setVisible(false);
	this.dispose();
    }

    /**
     * Returns the user's answer.
     *
     * @return true if user answered yes and false if user answered no or closed the dialog
     */
    public boolean getResult() {
	return result;
    }
}
