// Matrix - algorithm simulation system
// Copyright (C) 2000- 2007 Matrix group
// (See the AUTHORS file and the author tag below for more information
// on the authors.)
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/* $Id: LayoutSize.java,v 1.6 2007/09/10 08:11:06 vkaravir Exp $ */

package matrix.visual;

/**
 * A (width,height) pair for specifying sizes of nodes and layouts in
 * layout coordinates. (This class is just like java.awt.Dimension,
 * but the values are supposed to be in layout coordinates.)
 *
 * @author Riku Saikkonen
 */
public class LayoutSize {
    public int width, height;

    public LayoutSize(int width, int height) {
        this.width = width;
        this.height = height;
    }

    public String toString() {
	return "["+width+"x"+height+"]";
    }
}
