//Matrix - algorithm simulation system
//Copyright (C) 2000- 2007 Matrix group
//(See the AUTHORS file and the author tag below for more information
//on the authors.)

//This program is free software; you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation; either version 2 of the License, or
//(at your option) any later version.

//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.

//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/* $Id $ */

package matrix.visual;

import java.awt.*;

import matrix.structures.FDT.*;
import matrix.structures.FDT.substructures.Vertex;

/**
 * Layout where all the nodes (also the one's which are not connected)
 * are on fixed positions on the ring of the circle.
 * 
 * @author lhakulin
 */
public class VisualFixedCircleLayoutGraph extends VisualCircleLayoutGraph {

    public VisualFixedCircleLayoutGraph(Graph g) { 
        super(g); 
    }

    public VisualFixedCircleLayoutGraph(Vertex v) { 
        super(v); 
    }

    protected LayoutSize doActualLayout() {
    	
    	if (nodeList == null){
            Component[] com = getItems();
            nodeList = new VisualGraphComponent[com.length];
            System.arraycopy(com, 0, nodeList, 0, com.length);
    	}
    	
        int wid = 0, hei = 0;
        nodes = nodeList.length;
        xCoord = new double[nodes];
        yCoord = new double[nodes];
        if (lenAdjust == false) {
            len = calculateEdgeLength();
        }
        double minimumEdgeLength = calculateMaximumWidth();
        
        circleLayout(minimumEdgeLength + EDGE_ADD_LENGTH);
        LayoutSize lays = assignCoordinates(wid);
        wid += lays.width;
        hei = Math.max(hei, lays.height);

        return new LayoutSize(wid, hei);
    }


}
