// Matrix - algorithm simulation system
// Copyright (C) 2000- 2007 Matrix group
// (See the AUTHORS file and the author tag below for more information
// on the authors.)
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/* $Id: VisualLabel.java,v 1.21 2007/09/10 08:11:07 vkaravir Exp $ */

package matrix.visual;

import java.awt.Color;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics;

import matrix.structures.FDT.probe.Key;

public class VisualLabel extends VisualKey {

    public VisualLabel(Key k) {
        super(k);
    }

    /*
    public void setColor(Graphics g) {
        if (getParent() instanceof VisualType)
            ((VisualType)getParent()).setColor(g);
    }
    */
    private Font myFont = null;

    public void paintComponent(Graphics g) {
        super.paintComponent(g);
        if (g == null) {
            return;
            //Note.warning(this, "Graphics not defined");
        }
        int x = 1;
        int y = 1;
        int w = width-2;
        int h = height-2;
        
        setBackgroundColor(g);

        Font font = getFont();
        String keyLabel = getKey();
        if (font != null) {
            if ((font != lastFont) || (keyLabel != lastKey)) {
                FontMetrics fm = getFontMetrics(font);
                lastFont = font;
                textX = x + (w - fm.stringWidth(keyLabel))/2;
                textY = y + h - (h - fm.getHeight())/2 - fm.getDescent();
            }
            //setColor(g);
            g.setColor(Color.white); 
            g.drawString(keyLabel, textX-2, textY-1);
            g.drawString(keyLabel, textX-2, textY+1);

            g.drawString(keyLabel, textX-1, textY-1);
            g.drawString(keyLabel, textX-1, textY+1);
            g.drawString(keyLabel, textX+1, textY-1);
            g.drawString(keyLabel, textX+1, textY+1);

            //setPenColor(g);
            g.setColor(Color.black);
            g.drawString(keyLabel, textX, textY);
            g.drawString(keyLabel, textX-1, textY);

            setPenColor(g);
            //resetColor(g);
        }
    }
    
    public void doLayout() {
        Font f = super.getFont();
        if (f == null)
            return;

        if (!((myFont != null) &&
              (myFont.getName().equals(f.getName())) &&
              (myFont.getStyle() == f.getStyle()) &&
              (myFont.getSize() == (f.getSize()/2))))
            myFont = new Font(f.getName(), f.getStyle(), f.getSize()/2);
        super.doLayout();
    }

}
