// Matrix - algorithm simulation system
// Copyright (C) 2000- 2007 Matrix group
// (See the AUTHORS file and the author tag below for more information
// on the authors.)
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/* $Id: VisualLayeredTree.java,v 1.21 2007/09/10 08:11:10 vkaravir Exp $ */

package matrix.visual;

import matrix.structures.FDT.Tree;
//import matrix.structures.memory.Head;

/**
 * Draws a tree using the Layered-Tree-Draw algorithm (Algorithm 3.1
 * in Battista et. al., _Graph Drawing_), extended to support
 * non-binary trees and variable-size nodes
 *
 * @author Riku Saikkonen
 * @version $Revision: 1.21 $
 * @see VisualLayeredTreeComponent
 */
public class VisualLayeredTree extends VisualTree {

    public VisualLayeredTree(Tree t) {
        super(t);
    }

    public String getRepresentationName() {
        return "Layered Tree";
    }

    protected VisualTreeComponent createNewComponent(Tree t, 
                                                     VisualTreeComponent f) {
	/* Code removed because of bug fix repoted in flyspray Task #45 
	boolean h=hasRepresentation(t);
	if (h)
	    return new VisualLayeredTreeComponent(null,f);
	    else*/
	return new VisualLayeredTreeComponent(t,f);
    }    

    protected LayoutSize doActualLayout() {
        VisualLayeredTreeComponent root =
            (VisualLayeredTreeComponent) getRootNode();

        root.updateLayoutInformation(0);
        root.doFinalLayout(0, 0);
        
        return new LayoutSize(root.getContours().getWidth(),
                              root.getContours().getHeight());
    }
}
