// Matrix - algorithm simulation system
// Copyright (C) 2000- 2007 Matrix group
// (See the AUTHORS file and the author tag below for more information
// on the authors.)
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package prototype.ui;

import javax.swing.JTextArea;


/**
   A text label that wraps lines. The background color of the text is grey
   and the text is surrounded by a border line.
   @see java.awt.Label
   @author Panu Silvasti
*/
public class WrappingLabel  extends JTextArea {

    public final static int COLUMNS=0;


    public WrappingLabel() {
        this("");
    }


    public WrappingLabel(int rows, int columns) {
	super("", rows, columns);
		enableInputMethods(true);
        setEditable(true);
    }

    public WrappingLabel(String s) {
        super(s,countLines(s),COLUMNS);
        enableInputMethods(true);
        setEditable(true);
    }


    public void setText(String s) {
        if (s == null || s.equals("")) {
            super.setText("");
        }
        else {
            super.setText(s);
            //setRows(countLines(s)+1);
        }
    }


    public void append(String s) {
	super.append(s);
	//setRows(countLines(getText())+1);
    }


    private static int countLines(String s) {
        int count = 1;
        for (int i = 0; i < s.length(); i++) {
            if (s.charAt(i) == '\n') {
                count++;
            }
        }
        return count;
    }
}
