// Matrix - algorithm simulation system
// Copyright (C) 2000- 2007 Matrix group
// (See the AUTHORS file and the author tag below for more information
// on the authors.)
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
package tests.matrix.structures.spatial.CDT.probe;

// TODO This isn't a proper unit test yet, in that it doesn't make assertions.

import matrix.structures.spatial.CDT.probe.RTree;
import matrix.structures.spatial.FDT.probe.Point;
import junit.framework.TestCase;

public class RTreeTest extends TestCase {
	
	private RTree rtree;
	private int counter = 0;

	public RTreeTest(String s) {
		super(s);
	}

	public static void main(String[] args) {
		junit.textui.TestRunner.run(RTreeTest.class);
	}
	
	protected void setUp() throws Exception {
		System.out.println(counter++ + ": ** Creating an empty 2-3-R-tree **");
		this.rtree = new RTree(2, 3);
		print();
	}

	protected void tearDown() throws Exception {
		System.out.println(counter++ + ": ** Destroying the tree. **");
		this.rtree = null;
	}
	
	private void print() {
		System.out.println(this.rtree);
		
	}
	
	private void insert(Point p) {
		System.out.println(counter++ + ": ** Inserting point (" + p.getX() + "," + p.getY() + ") **");
		this.rtree.insert(p);
		print();
	}
	
	private void delete(Point p) {
		System.out.println(counter++ + ": ** Deleting point (" + p.getX() + "," + p.getY() + ") **");
		this.rtree.delete(p);
		print();
	}
	
	private Point point(double x, double y) {
		return new Point(x, y, "(" + x + "," + y + ")");
	}

	// TODO Design a test case.
	public final void test() {
		insert(point(2,2));
		insert(point(4,8));
		insert(point(7,7));
		insert(point(23,17));
		insert(point(13,19));
		insert(point(17,23));
		insert(point(47,29));
		insert(point(9,5));
		insert(point(12,17));
		insert(point(62,87));
		insert(point(42,57));
		insert(point(43,59));
		insert(point(13,18));
		insert(point(14,19));
		insert(point(24,18));
		insert(point(23,19));
		insert(point(25,20));
		delete(point(25,20));
		delete(point(23,19));
		delete(point(24,18));
		delete(point(14,19));
		delete(point(13,18));
		delete(point(43,59));
		delete(point(42,57));
		delete(point(62,87));
		delete(point(12,17));
		delete(point(9,5));
		delete(point(47,29));
		delete(point(17,23));
		delete(point(13,19));
		delete(point(23,17));
		delete(point(7,7));
		delete(point(4,8));
		delete(point(2,2));
	}
}
