// MatrixPro - algorithm simulation system
// Copyright (C) 2000-2007 See the AUTHORS file and the author tag
// below for more information on the authors.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package matrixpro.toolbar;

import javax.swing.JComponent;

/**
 * Abstract superclass for components used in <code>Toolbar</code>
 * 
 * @version $Id: ToolbarComponent.java,v 1.6 2007/09/10 08:32:31 vkaravir Exp $
 */
public abstract class ToolbarComponent {
    /** Updates this component. By default does nothing. */
    public void update() {
    }

    /**
     * Returns a description of this component. By default returns the name of
     * the class.
     */
    public String getDescription() {
        return this.getClass().getName();
    }

    /** Returns the Swing-component that will be added to the toolbar. */
    public abstract JComponent getComponent();

    /**
     * Returns a new instance of this component. All subclasses must "override"
     * this method.
     */
    public static ToolbarComponent getNewInstance(Toolbar tb) {
        return null;
    }
}
