// MatrixPro - algorithm simulation system
// Copyright (C) 2000-2007 See the AUTHORS file and the author tag
// below for more information on the authors.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/* $Id: MicroStepForwardComponent.java,v 1.8 2007/09/10 08:39:10 vkaravir Exp $ */
package matrixpro.toolbar.components;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JComponent;

import matrix.animation.Animator;
import matrix.util.ApplicationAdapter;

import matrixpro.toolbar.Toolbar;
import matrixpro.toolbar.ToolbarComponent;

public class MicroStepForwardComponent extends ToolbarComponent implements
        ActionListener {
    private Toolbar tb;

    private JButton button;

    public MicroStepForwardComponent(Toolbar tb) {
        this.tb = tb;
        button = new JButton("Microstep forward");
        button.addActionListener(this);
    }

    public void actionPerformed(ActionEvent e) {
        Animator animator = ApplicationAdapter.getApplication().getAnimator();
        if (animator.hasNextOperation()) {
            animator.GoTo(animator.getState() + 1, animator.getMaximum());
            tb.updateApplication();
        }
    }

    public String getDescription() {
        return "Takes one microstep forward.";
    }

    public JComponent getComponent() {
        return button;
    }

    public static ToolbarComponent getNewInstance(Toolbar tb) {
        return new MicroStepForwardComponent(tb);
    }
}
