// MatrixPro - algorithm simulation system
// Copyright (C) 2000-2007 See the AUTHORS file and the author tag
// below for more information on the authors.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package matrixpro.util;

/**
 * A class representing a property; a name and a value pair.
 * 
 * @version $Id: Property.java,v 1.5 2007/09/10 08:35:53 vkaravir Exp $
 */
public class Property {
    private String name, value;

    /**
     * Constructs a new <code>Property</code> with the given name and value.
     */
    public Property(String name, String value) {
        this.name = name;
        this.value = value;
    }

    /** Returns the name of this Property. */
    public String getName() {
        return name;
    }

    /** Returns the value of this Property. */
    public String getValue() {
        return value;
    }

    /** Return a <code>String</code> representation of this object. */
    public String toString() {
        return name + "=" + value;
    }
}
