// MatrixPro - algorithm simulation system
// Copyright (C) 2000-2007 See the AUTHORS file and the author tag
// below for more information on the authors.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package matrixpro.util;

import java.io.File;

import javax.swing.filechooser.FileFilter;

/**
 * <code>FileFilter</code> that accepts all the files given to it. The
 * description of this filter can be set in the constructor.
 * 
 * @version $Id: SimpleFileFilter.java,v 1.6 2007/09/10 08:35:53 vkaravir Exp $
 */
public class SimpleFileFilter extends FileFilter {
    /** Description of this filter. */
    private String descr;

    /**
     * Initializes a new instance of <code>SimpleFileFilter</code>.
     * 
     * @param descr
     *            The description of this filter.
     * @see #getDescription()
     */
    public SimpleFileFilter(String descr) {
        this.descr = descr;
    }

    /**
     * Since this filter accepts all files, this method always returns true.
     */
    public boolean accept(File f) {
        return true;
    }

    /** Returns the description of this filter. */
    public String getDescription() {
        return descr;
    }
}
