// MatrixPro - algorithm simulation system
// Copyright (C) 2000-2007 See the AUTHORS file and the author tag
// below for more information on the authors.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package matrixpro.util.html;

import java.net.MalformedURLException;
import java.net.URL;

import javax.swing.text.Document;
import javax.swing.text.ViewFactory;
import javax.swing.text.html.HTMLEditorKit;

public class ResourceHTMLEditorKit extends HTMLEditorKit {
    private ViewFactory factory;

    public ResourceHTMLEditorKit() {
        super();
        factory = new ResourceHTMLFactory();
    }

    public ViewFactory getViewFactory() {
        // System.out.println("getViewFactory");
        return factory;
    }

    public Document createDefaultDocument() {
        Document d = super.createDefaultDocument();

        d.putProperty("IgnoreCharsetDirective", new Boolean(true));
        try {
            d.putProperty("StreamDescriptionProperty", new URL(
                    "http://resources/"));
        } catch (MalformedURLException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return d;
    }

}
